Bug 809945 - Bug found in python-markupsafe-0.11-4.fc17 using gcc-with-cpychecker static analyzer
Bug found in python-markupsafe-0.11-4.fc17 using gcc-with-cpychecker static a...
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: python-markupsafe (Show other bugs)
19
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Kyle VanderBeek
Fedora Extras Quality Assurance
http://fedorapeople.org/~dmalcolm/gcc...
:
Depends On:
Blocks: cpychecker
  Show dependency treegraph
 
Reported: 2012-04-04 13:36 EDT by Dave Malcolm
Modified: 2014-05-09 22:51 EDT (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2014-05-09 22:51:16 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Dave Malcolm 2012-04-04 13:36:45 EDT
Description of problem:
I've been writing an experimental static analysis tool to detect bugs commonly occurring within C Python extension modules:
  https://fedorahosted.org/gcc-python-plugin/
  http://gcc-python-plugin.readthedocs.org/en/latest/cpychecker.html
  http://fedoraproject.org/wiki/Features/StaticAnalysisOfPythonRefcounts

I ran the latest version of the tool (in git master; post 0.9) on
python-markupsafe-0.11-4.fc17.src.rpm, and it reports various errors.

You can see a list of errors here, triaged into categories (from most significant to least significant):
http://fedorapeople.org/~dmalcolm/gcc-python-plugin/2012-04-04/python-markupsafe-0.11-4.fc17/

I've manually reviewed the issues reported by the tool.

Within the category "Segfaults within error-handling paths" most of the 12 issues reported appear to be at import time, and thus inconsequential.  However this one:
  markupsafe/_speedups.c:escape:dereferencing NULL (s->ob_refcnt) at markupsafe/_speedups.c:157
looks like a genuine crasher for the (low-memory?) case where escape_unicode() fails.

Within the other categories ("Possible reference leaks" and "Returning (PyObject*)NULL without setting an exception") the issues reported appear to be false positives/inconseqential.

There may of course be other bugs in my checker tool.

Hope this is helpful; let me know if you need help reading the logs that the tool generates - I know that it could use some improvement.

Version-Release number of selected component (if applicable):
python-markupsafe-0.11-4.fc17
gcc-python-plugin post-0.9 git 796fa7a73adfddb182c2edad70694b5ebca337b9 running the checker in an *f16* chroot
Comment 1 Fedora End Of Life 2013-04-03 11:49:55 EDT
This bug appears to have been reported against 'rawhide' during the Fedora 19 development cycle.
Changing version to '19'.

(As we did not run this process for some time, it could affect also pre-Fedora 19 development
cycle bugs. We are very sorry. It will help us with cleanup during Fedora 19 End Of Life. Thank you.)

More information and reason for this action is here:
https://fedoraproject.org/wiki/BugZappers/HouseKeeping/Fedora19
Comment 2 Orion Poplawski 2014-05-09 22:51:16 EDT
Quite old, closing.

Note You need to log in before you can comment on or make changes to this bug.